#!/usr/bin/env batchflow
<?xml version="1.0"?>
<Document>
  <Network type="subnet" name="MAIN">
    <Node name="node_LOOP0_1" type="LOOP0" x="100" y="100">
    </Node>
    <NetOutput name="x0" node="node_LOOP0_1" terminal="x0" object_type="any" description="Dynamically added outputs"/>
    <NetOutput name="x1" node="node_LOOP0_1" terminal="x1" object_type="any" description="Dynamically added outputs"/>
    <NetOutput name="x2" node="node_LOOP0_1" terminal="x2" object_type="any" description="Dynamically added outputs"/>
    <NetOutput name="all" node="node_LOOP0_1" terminal="all" object_type="any" description="Dynamic"/>
    <NetOutput name="OUTPUT" node="node_LOOP0_1" terminal="OUTPUT" object_type="Map&amp;lt;int,ObjectRef&amp;gt;" description="The same as input."/>
  </Network>
  <Network type="iterator" name="LOOP0">
    <Node name="node_LocalizeMUSIC_1" type="LocalizeMUSIC" x="650" y="100">
      <Parameter name="MUSIC_ALGORITHM" type="string" value="SEVD" description="Sound Source Localization Algorithm. If SEVD, NOISECM will be ignored"/>
      <Parameter name="TF_CHANNEL_SELECTION" type="object" value="&lt;Vector&lt;int&gt; &gt;" description="Microphone channels for localization. If vacant, all channels will be used."/>
      <Parameter name="LENGTH" type="int" value="512" description="The length of a frame (per channel)."/>
      <Parameter name="SAMPLING_RATE" type="int" value="16000" description="Sampling Rate (Hz)."/>
      <Parameter name="A_MATRIX" type="string" value="tf16000.zip" description="Filename of a transfer function matrix."/>
      <Parameter name="WINDOW" type="int" value="50" description="The number of frames used for calculating a correlation function."/>
      <Parameter name="WINDOW_TYPE" type="string" value="FUTURE" description="Window selection to accumulate a correlation function. If PAST, the past WINDOW frames from the current frame are used for the accumulation. If MIDDLE, the current frame will be the middle of the accumulated frames. If FUTURE, the future WINDOW frames from the current frame are used for the accumulation. FUTURE is the default from version 1.0, but this makes a delay since we have to wait for the future information. PAST generates a internal buffers for the accumulation, which realizes no delay for localization."/>
      <Parameter name="PERIOD" type="int" value="50" description="The period in which the source localization is processed."/>
      <Parameter name="NUM_SOURCE" type="int" value="2" description="Number of sources, which should be less than number of channels."/>
      <Parameter name="MIN_DEG" type="int" value="-180" description="source direction (lower)."/>
      <Parameter name="MAX_DEG" type="int" value="180" description="source direction (higher)."/>
      <Parameter name="LOWER_BOUND_FREQUENCY" type="int" value="500" description="Lower bound of frequency (Hz) used for correlation function calculation."/>
      <Parameter name="UPPER_BOUND_FREQUENCY" type="int" value="5000" description="Upper bound of frequency (Hz) used for correlation function calculation."/>
      <Parameter name="SPECTRUM_WEIGHT_TYPE" type="string" value="Uniform" description="MUSIC spectrum weight for each frequency bin."/>
      <Parameter name="A_CHAR_SCALING" type="float" value="1" description="Scaling factor of the A-Weight with respect to frequency"/>
      <Parameter name="MANUAL_WEIGHT_SPLINE" type="object" value="&lt;Matrix&lt;float&gt; &lt;rows 2&gt; &lt;cols 5&gt; &lt;data 0.0 2000.0 4000.0 6000.0 8000.0 1.0 1.0 1.0 1.0 1.0&gt; &gt;" description="MUSIC spectrum weight for each frequency bin. This is a 2 by M matrix. The first row represents the frequency, and the second row represents the weight gain. &quot;M&quot; represents the number of key points for the spectrum weight. The frequency range between M key points will be interpolated by spline manner. The format is &quot;&amp;lt;Matrix&amp;lt;float&amp;gt; &amp;lt;rows 2&amp;gt; &amp;lt;cols 2&amp;gt; &amp;lt;data 1 2 3 4&amp;gt; &amp;gt;&quot;."/>
      <Parameter name="MANUAL_WEIGHT_SQUARE" type="object" value="&lt;Vector&lt;float&gt; 0.0 2000.0 4000.0 6000.0 8000.0&gt;" description="MUSIC spectrum weight for each frequency bin. This is a M order vector. The element represents the frequency points for the square wave. &quot;M&quot; represents the number of key points for the square wave weight. The format is &quot;&amp;lt;Vector&amp;lt;float&amp;gt; 1 2 3 4&amp;gt;&quot;."/>
      <Parameter name="ENABLE_EIGENVALUE_WEIGHT" type="bool" value="true" description="If true, the spatial spectrum is weighted depending on the eigenvalues of a correlation matrix. We do not suggest to use this function with GEVD and GSVD, because the NOISECM changes the eigenvalue drastically. Only useful for SEVD."/>
      <Parameter name="MAXNUM_OUT_PEAKS" type="int" value="-1" description="Maximum number of output peaks. If MAXNUM_OUT_PEAKS = NUM_SOURCE, this is compatible with HARK version 1.0. If MAXNUM_OUT_PEAKS = 0, all local maxima are output. If MAXNUM_OUT_PEAKS &amp;lt; 0, MAXNUM_OUT_PEAKS is set to NUM_SOURCE. If MAXNUM_OUT_PEAKS &amp;gt; 0, number of output peaks is limited to MAXNUM_OUT_PEAKS."/>
      <Parameter name="DEBUG" type="bool" value="false" description="Debug option. If the parameter is true, this node outputs sound localization results to a standard output."/>
    </Node>
    <Node name="node_SourceTracker_1" type="SourceTracker" x="1060" y="320">
      <Parameter name="THRESH" type="float" value="23.5" description="Power threshold for localization results. A localization result with higher power than THRESH is tracked, otherwise ignored."/>
      <Parameter name="PAUSE_LENGTH" type="float" value="1000" description="Life duration of source in ms. When any localization result for a source is found for more than PAUSE_LENGTH / 10 iterations, the source is terminated. [default: 800]"/>
      <Parameter name="MIN_SRC_INTERVAL" type="float" value="30" description="Source interval threshold in degree. When the angle between a localization result and a source is smaller than MIN_SRC_INTERVAL, the same ID is given to the localization result. [default: 20]"/>
      <Parameter name="MIN_ID" type="int" value="0" description="Minimum ID of source locations. MIN_ID should be greater than 0 or equal."/>
      <Parameter name="DEBUG" type="bool" value="false" description="Output debug information if true [default: false]"/>
    </Node>
    <Node name="node_MultiFFT_1" type="MultiFFT" x="420" y="100">
      <Parameter name="LENGTH" type="int" value="512" description="FFT length in sample. [default: 512]"/>
      <Parameter name="WINDOW" type="string" value="CONJ" description="A window function for FFT. WINDOW should be CONJ, HAMMING, RECTANGLE, or HANNING. [default: CONJ]"/>
      <Parameter name="WINDOW_LENGTH" type="int" value="512" description="Window length of the window function. [default: 512]"/>
    </Node>
    <Node name="node_HarkParamsDynReconf_1" type="HarkParamsDynReconf" x="640" y="320">
      <Parameter name="PORT" type="int" value="9999" description="Port number of audio input server."/>
      <Parameter name="ENABLE_DEBUG" type="bool" value="false" description="print debug message of this module in case of true."/>
    </Node>
    <Node name="node_PyCodeExecutor3_1" type="PyCodeExecutor3" x="1730" y="320">
      <Parameter name="DIRECTORY_NAME" type="string" value="." description="[optional] The directory name of your python code. It will inserted to sys.path."/>
      <Parameter name="MODULENAME" type="string" value="999" description="Your python module name to import, i.e., your python code file name WITHOUT extension."/>
      <Parameter name="CLASSNAME" type="string" value="HarkNode" description="Your class name to call in this node."/>
      <Parameter name="DEBUG" type="bool" value="false" description="Debug option. If true, it prints input list and output list."/>
    </Node>
    <Node name="node_SourceIntervalExtender_1" type="SourceIntervalExtender" x="1320" y="320">
      <Parameter name="PREROLL_LENGTH" type="int" value="50" description="Preroll length in frame. [default: 50]"/>
    </Node>
    <Node name="node_Synthesize_1" type="Synthesize" x="580" y="560">
      <Parameter name="LENGTH" type="int" value="512" description="Size of window length in sample. [default: 512]"/>
      <Parameter name="ADVANCE" type="int" value="160" description="The length in sample between a frame and a previous frame. [default: 160]"/>
      <Parameter name="SAMPLING_RATE" type="int" value="16000" description="Sampling rate (Hz) [default: 16000]."/>
      <Parameter name="MIN_FREQUENCY" type="int" value="125" description="Minimum frequency (Hz) [default: 125]"/>
      <Parameter name="MAX_FREQUENCY" type="int" value="7900" description="Maximum frequency (Hz) [default: 7900]"/>
      <Parameter name="WINDOW" type="string" value="HAMMING" description="A window function for overlap-add. WINDOW should be CONJ, HAMMING, RECTANGLE, or HANNING. [default: HAMMING]"/>
      <Parameter name="OUTPUT_GAIN" type="float" value="1" description="Output gain factor. [default: 1.0]"/>
    </Node>
    <Node name="node_SaveWavePCM_1" type="SaveWavePCM" x="800" y="560">
      <Parameter name="BASENAME" type="string" value="sep/sep_" description="Basename of files. [default: sep_]"/>
      <Parameter name="ADVANCE" type="int" value="160" description="The shift length beween adjacent frames (in samples)[default: 160]."/>
      <Parameter name="SAMPLING_RATE" type="int" value="16000" description="Sampling rate (in samples)[default: 16000]."/>
      <Parameter name="BITS" type="string" value="int16" description="Bit format of samples. int16 and int24  bits are supported."/>
      <Parameter name="INPUT_BITS" type="string" value="int16" description="Bit format of input wav file."/>
    </Node>
    <Node name="node_BeamForming_1" type="BeamForming" x="240" y="560">
      <Parameter name="LENGTH" type="int" value="512" description="The frame length of each channel (in samples) [default: 512]."/>
      <Parameter name="ADVANCE" type="int" value="160" description="The shift length beween adjacent frames (in samples)[default: 160]."/>
      <Parameter name="SAMPLING_RATE" type="int" value="16000" description="Sampling rate (Hz) [default: 16000]."/>
      <Parameter name="LOWER_BOUND_FREQUENCY" type="int" value="0" description="Lower bound of frequency (Hz). [default: 0]"/>
      <Parameter name="UPPER_BOUND_FREQUENCY" type="int" value="8000" description="Upper bound of frequency (Hz). [default: 8000]"/>
      <Parameter name="TF_CONJ_FILENAME" type="string" value="tf16000.zip" description="Filename of a pre-measured transfer function for separation."/>
      <Parameter name="INITW_FILENAME" type="string" value="" description="Filename of an initial separation matrix. If specified, a matrix in INITW_FILENAME is used as an initial separation matrix. Otherwise, initial separation matrix is estimated from the geometrical relationship or pre-measured TF according to TF_CONJ."/>
      <Parameter name="GICA_SS_METHOD" type="string" value="ADAPTIVE" description="The calculation method for SS step size parameter corresponding to the blind separation part. &quot;FIX&quot; uses a fixed step size as GICA_SS_MYU, &quot;LC_MYU&quot; uses the same value as GICA_LC_MYU, and &quot;ADAPTIVE&quot; adaptively estimates an optimal step size. This is used only when BF_METHOD=GICA. [default: ADAPTIVE]"/>
      <Parameter name="GHDSS_SS_METHOD" type="string" value="ADAPTIVE" description="The calculation method for SS step size parameter corresponding to the blind separation part. &quot;FIX&quot; uses a fixed step size as GHDSS_SS_MYU, &quot;LC_MYU&quot; uses the same value as GHDSS_LC_MYU, and &quot;ADAPTIVE&quot; adaptively estimates an optimal step size. This is used only when BF_METHOD=GHDSS. [default: ADAPTIVE]"/>
      <Parameter name="GICA_SS_MYU" type="float" value="0.001" description="SS step size value if GICA_SS_METHOD=FIX. SS adaptive step size scaler if GICA_SS_METHOD=ADAPTIVE. [default 0.001]"/>
      <Parameter name="GHDSS_SS_MYU" type="float" value="0.001" description="SS step size value if GHDSS_SS_METHOD=FIX. SS adaptive step size scaler if GHDSS_SS_METHOD=ADAPTIVE. [default 0.001]"/>
      <Parameter name="LCMV_LC_METHOD" type="string" value="ADAPTIVE" description="The calculation method for LC step size corresponding to geometric constraints. &quot;FIX&quot; uses a fixed value as LCMV_LC_MYU, and &quot;Adaptive&quot; adaptively estimates an optimal step size as LCMV_LC_MYU. This is used only when BF_METHOD=LCMV. [default: ADAPTIVE]"/>
      <Parameter name="GJ_LC_METHOD" type="string" value="ADAPTIVE" description="The calculation method for LC step size corresponding to geometric constraints. &quot;FIX&quot; uses a fixed value as GJ_LC_MYU, and &quot;Adaptive&quot; adaptively estimates an optimal step size as GJ_LC_MYU. This is used only when BF_METHOD=GJ. [default: ADAPTIVE]"/>
      <Parameter name="GICA_LC_METHOD" type="string" value="ADAPTIVE" description="The calculation method for LC step size corresponding to geometric constraints. &quot;FIX&quot; uses a fixed value as GICA_LC_MYU, and &quot;Adaptive&quot; adaptively estimates an optimal step size as GICA_LC_MYU. This is used only when BF_METHOD=GICA. [default: ADAPTIVE]"/>
      <Parameter name="GHDSS_LC_METHOD" type="string" value="ADAPTIVE" description="The calculation method for LC step size corresponding to geometric constraints. &quot;FIX&quot; uses a fixed value as GHDSS_LC_MYU, and &quot;Adaptive&quot; adaptively estimates an optimal step size as GHDSS_LC_MYU. This is used only when BF_METHOD=GHDSS. [default: ADAPTIVE]"/>
      <Parameter name="LCMV_LC_MYU" type="float" value="0.001" description="LC step size value if LCMV_LC_METHOD=FIX. LC adaptive step size scaler if LCMV_LC_METHOD=ADAPTIVE. [default 0.001]"/>
      <Parameter name="GJ_LC_MYU" type="float" value="0.001" description="LC step size value if GJ_LC_METHOD=FIX. LC adaptive step size scaler if GJ_LC_METHOD=ADAPTIVE. [default 0.001]"/>
      <Parameter name="GICA_LC_MYU" type="float" value="0.001" description="LC step size value if GICA_LC_METHOD=FIX. LC adaptive step size scaler if GICA_LC_METHOD=ADAPTIVE and if GICA_SS_METHOD=LC_MYU. [default 0.001]"/>
      <Parameter name="GHDSS_LC_MYU" type="float" value="0.001" description="LC step size value if GHDSS_LC_METHOD=FIX. LC adaptive step size scaler if GHDSS_LC_METHOD=ADAPTIVE and if GHDSS_SS_METHOD=LC_MYU. [default 0.001]"/>
      <Parameter name="GHDSS_LC_CONST" type="string" value="FULL" description="The calculation method for geometric constraints. &quot;FULL&quot; uses all elements of a matrix, and &quot;DIAG&quot; only uses diagonal parts. [default: FULL]"/>
      <Parameter name="GICA_SS_SCAL" type="float" value="1" description="Scaling factor of the nonlinear function for SS step size. [default: 1.0]"/>
      <Parameter name="GHDSS_SS_SCAL" type="float" value="1" description="Scaling factor of the nonlinear function for SS step size. [default: 1.0]"/>
      <Parameter name="GHDSS_NOISE_FLOOR" type="float" value="0" description="Noise floor value. [default 0.0]"/>
      <Parameter name="GHDSS_UPDATE" type="string" value="STEP" description="The update method of separation matrix. &quot;STEP&quot; updates W sequentially, i.e., based on SS and then on LC cost. &quot;TOTAL&quot; updates W based on an integrated value of SS and LC cost [default: STEP]"/>
      <Parameter name="UPDATE_METHOD_W" type="string" value="ID" description="Switching method of separation matrix, W. [default: ID]"/>
      <Parameter name="UPDATE_ACCEPT_DISTANCE" type="float" value="300" description="Angle allowance to switch separation matrix in mm. This parameter is available when UPDATE_METHOD_W is POS or ID_POS and when INITW_FILENAME is set. [default: 300.0]"/>
      <Parameter name="EXPORT_W" type="bool" value="true" description="Separation matrix W is exported if true. [default: false]"/>
      <Parameter name="EXPORT_W_FILENAME" type="string" value="W.txt" description="The filename to export W."/>
      <Parameter name="BF_METHOD" type="string" value="DS" description="beam-forming algorithm type."/>
      <Parameter name="ENABLE_DEBUG" type="bool" value="false" description="enable debug print"/>
    </Node>
    <Node name="node_PyCodeExecutor3_2" type="PyCodeExecutor3" x="100" y="100">
      <Parameter name="DIRECTORY_NAME" type="string" value="." description="[optional] The directory name of your python code. It will inserted to sys.path."/>
      <Parameter name="MODULENAME" type="string" value="AudioStreamRepeaterFromWave" description="Your python module name to import, i.e., your python code file name WITHOUT extension."/>
      <Parameter name="CLASSNAME" type="string" value="HarkNode" description="Your class name to call in this node."/>
      <Parameter name="DEBUG" type="bool" value="false" description="Debug option. If true, it prints input list and output list."/>
    </Node>
    <Link from="node_MultiFFT_1" output="OUTPUT" to="node_LocalizeMUSIC_1" input="INPUT"/>
    <Link from="node_LocalizeMUSIC_1" output="OUTPUT" to="node_SourceTracker_1" input="INPUT"/>
    <Link from="node_HarkParamsDynReconf_1" output="SourceTracker" to="node_SourceTracker_1" input="PARAMS"/>
    <Link from="node_HarkParamsDynReconf_1" output="LocalizeMUSIC" to="node_LocalizeMUSIC_1" input="PARAMS"/>
    <Link from="node_SourceTracker_1" output="OUTPUT" to="node_SourceIntervalExtender_1" input="SOURCES"/>
    <Link from="node_SourceIntervalExtender_1" output="OUTPUT" to="node_PyCodeExecutor3_1" input="input"/>
    <Link from="node_Synthesize_1" output="OUTPUT" to="node_SaveWavePCM_1" input="INPUT"/>
    <Link from="node_BeamForming_1" output="OUTPUT" to="node_Synthesize_1" input="INPUT"/>
    <Link from="node_MultiFFT_1" output="OUTPUT" to="node_BeamForming_1" input="INPUT_FRAMES"/>
    <Link from="node_SourceIntervalExtender_1" output="OUTPUT" to="node_BeamForming_1" input="INPUT_SOURCES"/>
    <Link from="node_PyCodeExecutor3_2" output="AUDIO" to="node_MultiFFT_1" input="INPUT"/>
    <NetOutput name="x0" node="node_PyCodeExecutor3_1" terminal="x0" object_type="any" description="Dynamically added outputs"/>
    <NetOutput name="x1" node="node_PyCodeExecutor3_1" terminal="x1" object_type="any" description="Dynamically added outputs"/>
    <NetOutput name="x2" node="node_PyCodeExecutor3_1" terminal="x2" object_type="any" description="Dynamically added outputs"/>
    <NetOutput name="all" node="node_PyCodeExecutor3_1" terminal="all" object_type="any" description="Dynamically added outputs"/>
    <NetOutput name="OUTPUT" node="node_SaveWavePCM_1" terminal="OUTPUT" object_type="Map&amp;lt;int,ObjectRef&amp;gt;" description="The same as input."/>
    <NetCondition name="CONDITION" node="node_PyCodeExecutor3_2" terminal="NOT_EOF"/>
  </Network>
</Document>
